package gui.model;

import java.net.InetSocketAddress;

import common.Properties;
import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleObjectProperty;

/*
 * Modell-Klasse fuer die Einstellungen der App.
 */
public class Settings {
	private final ObjectProperty<InetSocketAddress> server;

    // Default constructor
    public Settings() {
    	this.server = new SimpleObjectProperty<InetSocketAddress> (new InetSocketAddress("localhost", Properties.PORT));
    }
    
    // Returns the server (InetSocketAddress)
    public ObjectProperty<InetSocketAddress> getSocketAddress() {
		return server;
	}
	
    // Sets the server (InetSocketAddress)
	public void setSocketAddress(InetSocketAddress server) {
		this.server.set(server);
	}
	
}
