package gui.model;

import javafx.beans.property.IntegerProperty;
import gui.view.SwitchControl;
import javafx.beans.property.BooleanProperty;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleObjectProperty;
import javafx.beans.property.SimpleBooleanProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.beans.property.ObjectProperty;

/*
 * Modell-Klasse fuer eine Weiche.
 */
public class Switch{

    private final StringProperty name;
    private final IntegerProperty id;
    private final BooleanProperty state;
    private final ObjectProperty<SwitchControl> controller;

    // Default constructor
    public Switch() {
        this(null, null, null);
    }

    // Constructor with some initial data
    public Switch(String name, Integer id){
    	this(name, id, null);
    }
    
 // Constructor with some more initial data
    public Switch(String name, Integer id, SwitchControl controller) {
        this.name = new SimpleStringProperty(name);
        this.id = new SimpleIntegerProperty(id);
        this.controller = new SimpleObjectProperty<SwitchControl>(controller);
        
        // Initialize the switch in a straigt (=false) state
        this.state = new SimpleBooleanProperty(false);
      
	}
    
    // Overrides the toString-functionality to return the instances value of name
    @Override
    public String toString() {
      return name.getValue();
    }
    
    // Returns the name
    public StringProperty getName() {
		return name;
	}
    
    // Sets the name
    public void setName(String name) {
		this.name.set(name);
	}

    // Returns the maerklin-id
	public IntegerProperty getMaerklinID() {
		return id;
	}

	// Returns the state
	public BooleanProperty getState() {
		return state;
	}
	
	// Sets the state
	public void setState(Boolean state) {
		this.state.set(state);
	}
	
	// Returns the objects matching controller-instance
	public ObjectProperty<SwitchControl> getController(){
		return controller;
	}
	
	// Sets the objects matching controller-instance
	public void setController(SwitchControl controller){
		this.controller.setValue(controller);
	}
}
