package server;


/*
 * MaerklinServerApplication startet den Server sowie den Listener, der 
 * die serverseitigen Modelle aktualisiert. Weiterhin initialisiert die Klasse 
 * zyklisch ein synchrones Status-Update fuer alle registrierten Clients.
 */
public class MaerklinServerApplication {
	
	// Defining a threshold value for when the status-update is to be executed (in milliseconds)
	private final static long updateThreshold = 500;

	public static void main(String[] args) {
		
		// Creating timestamp for the update-functionality
		long timestamp = System.currentTimeMillis();
		
		// Calling constructor
		MaerklinServer server = new MaerklinServer();
		
		// Starting listener-thread
		server.startListener();
		
		// Starting the client-handling
		server.listen();
				
		// Periodically checks if the update-threshold has been exceeded and potentially initializes the status update through statusUpdate
		while (true){
			if (System.currentTimeMillis()-timestamp >= updateThreshold) {
				server.statusUpdate();
				timestamp = System.currentTimeMillis();
			}
			else {
				try {
					Thread.sleep(50);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
	}

}
