package gui.view;

import javafx.fxml.FXML;
import javafx.scene.control.TabPane;

import org.controlsfx.control.StatusBar;

import gui.MainApp;

/*
 * Die Klasse RootLayoutController stellt den Controller fr die Bedienelemente des Basislayouts bereit. 
 */

public class RootLayoutController {
	@FXML
	private TabPane rootTabPane;
	@FXML
	private StatusBar statusBar;
	
	
	// Reference to the main application.
    private MainApp mainApp;

    /**
     * Is called by the main application to give a reference back to itself.
     * 
     * @param mainApp
     */
    public void setMainApp(MainApp mainApp) {
        this.mainApp = mainApp;
    }
    
    /**
     * get the tabs from the main app and load them into the local tabPane
     * can't be done in the constructor, since mainApp has to be set first
     */
    public void loadTabs(){
    	rootTabPane.getTabs().addAll(mainApp.getTabs()); 
    }
    
    // sets the StatusBar text
    public void setStatus(String status){
    	statusBar.setText(status);
    }
    
    // passes the Emergency Stop command to the mainApp
    public void emergencyStopHandler(){
    	mainApp.emergencyStopHandler();
    }
}
