package gui.view;

import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import javafx.scene.control.Button;

import java.net.InetSocketAddress;

import gui.MainApp;
import gui.model.Settings;

public class SettingsController {
	@FXML
	TextField serverIP;
	
	@FXML
	Button connectButton;
	
	private Settings settings;

	private MainApp mainApp;
	
	public SettingsController(){
	}
	
	/**
     * Initializes the controller class. This method is automatically called
     * after the fxml file has been loaded.
     */
    @FXML
    private void initialize() {
    }

    /**
     * Is called by the main application to give a reference back to itself.
     * 
     * @param mainApp
     */
    public void setMainApp(MainApp mainApp) {
        this.mainApp = mainApp;
    }
	/**
	 * is called by an OnClick event caused by the Connect Button.
	 * updates the Settings model to the currently selected IP Adress and
	 * calls the establishConnection method of the mainApp.
	 */    
	@FXML
	private void connectHandler(){
		InetSocketAddress address = new InetSocketAddress(serverIP.getText(), settings.getSocketAddress().get().getPort());
		settings.setSocketAddress(address);
		updateSettingsStatus();
		mainApp.establishConnetion();
	}
	
	// updates the GUI
	public void updateSettingsStatus(){   
		InetSocketAddress addr = settings.getSocketAddress().get();
    	StringBuilder status = new StringBuilder("Verbindung herstellen mit ");
    	status.append(addr.getHostName());
    	status.append(" (" + addr.getAddress() + ":" + addr.getPort() + ")");
    	mainApp.setStatus(status.toString());
    	if (mainApp.getConnectionEstablished()) {
			connectButton.setText("Verbindung trennen");
		}
		else {
			connectButton.setText("Verbindung herstellen");
		}
    }

	/**
     * updates the local reference of the selected settings model to the given one
     * 
     * @param Settings
     */
	public void setSettings(Settings settings) {
		this.settings = settings;	
	}
}
