package gui.view;

import javafx.fxml.FXML;
import javafx.scene.layout.VBox;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import gui.MainApp;
import gui.model.Switch;

public class SwitchListController {
	@FXML
	private VBox switchesVBox;
		
	// Reference to the main application.
    private MainApp mainApp;

    /**
     * The constructor.
     * The constructor is called before the initialize() method.
     */
    public SwitchListController(){
    	
    }

    /**
     * Initializes the controller class. This method is automatically called
     * after the fxml file has been loaded.
     */
    @FXML
    private void initialize() {
    	//setSwitchControls(); // would be nice to do this here, doesn't work until setMainApp has been called
    }

    /**
     * Is called by the main application to give a reference back to itself.
     * 
     * @param mainApp
     */
    public void setMainApp(MainApp mainApp) {
        this.mainApp = mainApp;
        
    }
    /**
     * this is where the magic happens!
     * kidding aside, this method creates and assigns a new SwitchControl instance to every switch defined in the mainApp.
     * it then adds these SwitchControls to the VBox provided in the SwitchList.fxml
     */
    public void setSwitchControls(){
    	ObservableList<Switch> switches = mainApp.getSwitches();
    	ObservableList<SwitchControl> switchControls = FXCollections.observableArrayList();
    	for ( int i=0; i<switches.size();i++ ){
    		switchControls.add(new SwitchControl(switches.get(i)));
    		switches.get(i).getController().get().setMainApp(mainApp);
    	};
    	switchesVBox.getChildren().addAll(switchControls);
    }
}
