package maerklinProject_ServerApplication;

import java.util.ArrayList;

public class Switch {
	
	static ArrayList<Switch> switches;
	
	private int switchID;
	int switchDirection;
	
	private MaerklinProtocol udpProtocol;
	private UDPListener listener;
	
	public Switch(){
		switches = new ArrayList<Switch>();
		udpProtocol = new MaerklinProtocol();
		listener = new UDPListener();
		switches.add(this);
	}
	
	public Switch(int id, int direction){
		switches = new ArrayList<Switch>();
		udpProtocol = new MaerklinProtocol();
		listener = new UDPListener();
		switches.add(this);
		try {
			setSwitchID(id);
			setSwitchDirection(direction);
		}
		catch(Exception e){
			System.out.println(e.getMessage());
		}
	}
	
	public void setSwitchID(int newSwitchID){
		switchID = newSwitchID;
	}
	
	public void setSwitchDirection(int newSwitchDirection) throws Exception {
		if (newSwitchDirection == 0x01 || newSwitchDirection == 0x00){
			switchDirection = newSwitchDirection;
		}
		else {
			Exception e = new Exception("No viable switch direction!");
			throw e;
		}
		udpProtocol.changeSwitchDirection(switchID, switchDirection);
		listener.listen();
		if (switchDirection != listener.getSwitchDirection()){
			Exception e = new Exception("Communication Error!");
			throw e;
		}
	}
	
	public void changeSwitchDirection() throws Exception {
		if (switchDirection == 0x00){
			setSwitchDirection(0x01);
		}
		else {
			setSwitchDirection(0x00);
		}
	}
	
	public int getSwitchID(){
		return switchID;
	}
	
	public int getSwitchDirection(){
		return switchDirection;
	}

}
