package maerklinUDPPraktikum;

import java.net.*;

import javax.xml.bind.DatatypeConverter;

public class MaerklinProtocol {
	
	private final static int port = 15731;
	private final static String ip ="192.168.74.118";
	
	public MaerklinProtocol(){
		//Nothing to do...
	}
	
	private void writeDatagram(String ip, int port, byte[] data){
		System.out.printf("\nGesendet: " + DatatypeConverter.printHexBinary(data));
		try(DatagramSocket socket = new DatagramSocket()){
			InetAddress  address = InetAddress.getByName(ip);
			DatagramPacket outgoingData = new DatagramPacket(data, data.length, address, port);
			socket.send(outgoingData);
		} 
		catch (Exception e) {
			e.printStackTrace();
		} 
	}
	
	public void changeEngineSpeed(int mfxAddress, int newEngineSpeed){
		byte[] engineSpeed = {(byte) Math.floor(newEngineSpeed/256), (byte) Math.floor(newEngineSpeed%256)};
		byte[] address = {(byte) Math.floor(mfxAddress/256), (byte) Math.floor(mfxAddress%256)};
		byte[] out = {(byte) 0x00, (byte) 0x08, (byte) 0x07, (byte) 0x78, (byte) 0x06, (byte) 0x00, (byte) 0x00, address[0], address[1], engineSpeed[0], engineSpeed[1], (byte) 0x00, (byte) 0x00};
		this.writeDatagram(ip, port, out);
	}
	
	public void changeEngineDirection(int mfxAddress, int newEngineDirection){
		byte engineDirection = (byte) Math.floor(newEngineDirection%256);
		byte[] address = {(byte) Math.floor(mfxAddress/256), (byte) Math.floor(mfxAddress%256)};
		byte[] out = {(byte) 0x00, (byte) 0x0A, (byte) 0x07, (byte) 0x78, (byte) 0x05, (byte) 0x00, (byte) 0x00, address[0], address[1], engineDirection, (byte) 0x00, (byte) 0x00, (byte) 0x00};
		this.writeDatagram(ip, port, out);
	}
	
	public void changeSwitchDirection(int mfxAddress, int newSwitchDirection){
		byte switchDirection = (byte) Math.floor(newSwitchDirection%256);
		byte[] address = {(byte) Math.floor(mfxAddress/256), (byte) Math.floor(mfxAddress%256)};
		byte[] out = {(byte) 0x00, (byte) 0x16, (byte) 0x07, (byte) 0x78, (byte) 0x06, (byte) 0x00, (byte) 0x00, address[0], address[1], switchDirection, (byte) 0x01, (byte) 0x00, (byte) 0x00};
		this.writeDatagram(ip, port, out);
	}
	
	public static void main(String args[]){
		UDPListener overwatch = new UDPListener();
		Engine ice = new Engine();
		Engine lok = new Engine();
		Switch weiche05 = new Switch();
		ice.setEngineID(0x0002);
		lok.setEngineID(0x4005);
		weiche05.setSwitchID(0x3005);
		overwatch.run();
		while(true){
			
		}
		/*try {
			//ice.setEngineDirection(3);
			//ice.setEngineSpeed(100);
			//weiche05.setSwitchDirection(0x00);
			//weiche05.changeSwitchDirection();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}*/
	}
}
