package briefmarkenautomat;

public class Briefmarkenautomat {
	
	private static UserInteraction ui;
	private static Sendungstyp sendung;
	private static Kasse kasse;
	
	public Briefmarkenautomat() {
		ui = new UserInteraction();
		sendung = new Sendungstyp();
		kasse = new Kasse();
	}
	
	private static int briefmarkenWaehlen(Typ sendungstyp) throws IllegalArgumentException{
		String uiInput;
		int anzahlBriefmarken = 0;
		System.out.println("Geben Sie die Anzahl der zu erwerbenden Briefmarken ein (max. 10)!\n");
		uiInput = ui.scan();
		try {
			anzahlBriefmarken = Integer.parseInt(uiInput);
		}
		catch (NumberFormatException e){
			System.out.println("Ungueltige Eingabe!");
			IllegalArgumentException err = new IllegalArgumentException(UserInteraction.UE_EXCEPTION);
			throw err;
		}
		if (anzahlBriefmarken <= 10 && anzahlBriefmarken > 0){
			return anzahlBriefmarken;
		}
		else if (anzahlBriefmarken <= 0){
			return 1;
		}
		else {
			return 10;
		}
	}
	
	private static void automat(){
		while (true) {
			try {
				String uiInput;
				double sendungshoehe;	// Initialisiere Variablen dermaßen, dass eine Exception geworfen wird, falls diese nicht mit Werten belegt werden.
				int sendungsgewicht;
				Typ sendungseigenschaften;
				int anzahlBriefmarken;
				System.out.println("%------------------------------ Programmstart ------------------------------%\n");
				System.out.println("Geben Sie die Hoehe Ihrer Sendung in Zentimetern ein!\n");
				uiInput = ui.scan();
				sendungshoehe = Double.parseDouble(uiInput);
				System.out.println("Geben Sie das Gewicht Ihrer Sendung in Gramm ein!\n");
				uiInput = ui.scan();
				sendungsgewicht = Integer.parseInt(uiInput);
				sendungseigenschaften = sendung.typ(sendungshoehe, sendungsgewicht);
				System.out.println("Sendungstyp: " + sendungseigenschaften.getBezeichnung() + "\nPorto: " + sendungseigenschaften.getPorto());
				anzahlBriefmarken = briefmarkenWaehlen(sendungseigenschaften);
				if (anzahlBriefmarken < 0){
					continue;
				}				
				double betrag = anzahlBriefmarken*sendungseigenschaften.getPorto();
				kasse.bezahlen(betrag, ui);
				System.out.println("%--------------------------- Auftrag abgeschlossen! ---------------------------%\n");
				System.out.println("%------------------------------ Programmneustart ------------------------------%\n");
			}
			catch (NumberFormatException e){
				System.out.println("Ungueltige Eingabe!");
				continue;
			}
			catch (IllegalArgumentException e){
				if (e.getMessage() == UserInteraction.EXIT_EXCEPTION){
					break;
				}
				else if (e.getMessage() == UserInteraction.PN_EXCEPTION || e.getMessage() == UserInteraction.UE_EXCEPTION){
					continue;
				}
				else {
					e.printStackTrace();
					break;
				}
			}
		}
		
		
		ui.closeScanner();
		System.out.println("%------------------------------ Programmsabbruch ------------------------------%\n");
	}

	public static void main(String[] args) {
		ui = new UserInteraction();
		sendung = new Sendungstyp();
		kasse = new Kasse();
		automat();
	}
}
