package briefmarkenautomat;

public class Kasse {
	
	final static double ZWEIEURO = 2.0;
	final static double EINEURO = 1.0;
	final static double FUENFZIGCENT = 0.5;
	final static double ZWANZIGCENT = 0.2;
	final static double ZEHNCENT = 0.1;
	final static double FUENFCENT = 0.05;
	final static Muenze[] MUENZEN = {new Muenze(ZWEIEURO, 5),
			new Muenze(2.0, 5),
			new Muenze(1.0, 5),
			new Muenze(0.5, 5),
			new Muenze(0.2, 5),
			new Muenze(0.1, 5),
			new Muenze(0.05, 5)
	};
	
	public Kasse(){
		// Nothing to do...
	}
	
	public void bezahlen(double betrag, UserInteraction ui) throws IllegalArgumentException {
		double differenz = Math.round(1000.0 * betrag) / 1000.0;;
		while (true){
			if (differenz <= 0){
				wechselgeldAusgeben(-differenz);
			}
			String uiInput;
			double zahlung;
			System.out.println("Zu zahlender Betrag: " + differenz + " Euro\n"
					+ "Geben Sie den zu zahlenden Betrag in Euro ein!\n"
					+ "Zulaessige Betraege: 2 Euro, 1 Euro, 0.5 Euro, 0.2 Euro, 0.1 Euro, 0.05 Euro\n");
			uiInput = ui.scan();
			try {
				zahlung = Double.parseDouble(uiInput);
			}
			catch (NumberFormatException e){
				System.out.println("Ungueltige Eingabe!");
				IllegalArgumentException err = new IllegalArgumentException(UserInteraction.UE_EXCEPTION);
				throw err;
			}
			int counter = 0;
			for(Muenze geld : MUENZEN){
				if (zahlung == geld.getWert()){
					differenz = differenz-zahlung;
					differenz = Math.round(1000.0 * differenz) / 1000.0;
					geld.increment();
					if (differenz <= 0){
						wechselgeldAusgeben(-differenz);;
					}
					break;
				}
				counter++;
			}
			if (counter == MUENZEN.length){
				System.out.println("Ungueltige Eingabe!");
				IllegalArgumentException e = new IllegalArgumentException(UserInteraction.UE_EXCEPTION);
				throw e;
			}
		}
	}
	
	public void wechselgeldAusgeben(double rueckgeld){
		double differenz = Math.round(1000.0 * rueckgeld) / 1000.0;;
		for(int i = 0; i < MUENZEN.length; i++){
			double betrag = MUENZEN[i].getWert();
			int counter = 0;
			while(differenz >= betrag && MUENZEN[i].getAnzahl() > 0){
				differenz = differenz-betrag;
				differenz = Math.round(1000.0 * differenz) / 1000.0;
				MUENZEN[i].decrement();
				counter++;
			}
			if (counter > 0){
				System.out.println("Wechselgeld: " + counter + " mal " + betrag + " Euro");
			}
		}
		if (differenz > 0.0){
			System.out.println("" + differenz + "Euro können nicht gewechselt werden!\n");
		}
	}

}
