package briefmarkenautomat;

public class Sendungstyp {
	
	private static final Typ[] SENDUNGSTYP = new Typ[] {
			new Typ("Postkarte", 0.45, 0.0, 0), 
			new Typ("Standardbrief", 0.7, 0.5, 20),
			new Typ("Kompaktbrief", 0.85, 1, 50), 
			new Typ("Grossbrief", 1.45, 2, 500), 
			new Typ("Maxibrief", 2.6, 5, 1000)
	};
	
	public Sendungstyp(){
		// Nothing to do...
	}
	
	public Typ typ(double hoehe, int gewicht) throws IllegalArgumentException{
		for (Typ sendung : SENDUNGSTYP){
			if (hoehe <= sendung.getMaxHoehe() && gewicht <= sendung.getMaxGewicht()){
				return sendung;
			}
		}
		IllegalArgumentException e = new IllegalArgumentException("Unbekannter Sendungstyp!");
		throw e;
	}
	
	/*public static void main(String[] args){
		postkarte = new Typ("Postkarte", 0.45, 0.0, 0);
		standardbrief = new Typ("Standardbrief", 0.7, 0.5, 20);
		kompaktbrief = new Typ("Kompaktbrief", 0.85, 1, 50);
		grossbrief = new Typ("Grossbrief", 1.45, 2, 500);
		maxibrief = new Typ("Maxibrief", 2.6, 5, 1000);
		sendungstyp = new Typ[] {postkarte, standardbrief, kompaktbrief, grossbrief, maxibrief};
		System.out.println(typ(0.3, 400).getBezeichnung());
		System.out.println(typ(3.3, 900).getBezeichnung());
		System.out.println(typ(0.3, 2000).getBezeichnung());
		System.out.println(typ(0.3, 400).getBezeichnung());
	}*/
}
