package gui.view;

import javafx.fxml.FXML;
import javafx.scene.control.TabPane;
import javafx.scene.layout.BackgroundFill;
import javafx.scene.paint.Color;

import org.controlsfx.control.StatusBar;

import gui.MainApp;

public class RootLayoutController {
	@FXML
	private TabPane rootTabPane;
	@FXML
	private StatusBar statusBar;
	
	
	// Reference to the main application.
    private MainApp mainApp;

    /**
     * The constructor.
     * The constructor is called before the initialize() method.
     */
    public RootLayoutController() {
    }

    /**
     * Initializes the controller class. This method is automatically called
     * after the fxml file has been loaded.
     */
    @FXML
    private void initialize() {
    	
    }

    /**
     * Is called by the main application to give a reference back to itself.
     * 
     * @param mainApp
     */
    public void setMainApp(MainApp mainApp) {
        this.mainApp = mainApp;
    }
    
    public void loadTabs(){
    	rootTabPane.getTabs().addAll(mainApp.getTabs()); //can't be in the constructor
    }
    
    public void setStatus(String status){
    	statusBar.setText(status);
    }
    
    public void emergencyStopHandler(){
    	mainApp.emergencyStopHandler();
    }
}
