package gui.view;

import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import javafx.scene.control.Button;
import javafx.scene.control.Label;

import java.net.InetSocketAddress;

import gui.MainApp;
import gui.model.Settings;

public class SettingsController {
	@FXML
	TextField serverIP;
	
	@FXML
	Button connectButton;
	@FXML
	Label server;
	
	private Settings settings;

	private MainApp mainApp;
	
	public SettingsController(){
	}
	
	/**
     * Initializes the controller class. This method is automatically called
     * after the fxml file has been loaded.
     */
    @FXML
    private void initialize() {
    }

    /**
     * Is called by the main application to give a reference back to itself.
     * 
     * @param mainApp
     */
    public void setMainApp(MainApp mainApp) {
        this.mainApp = mainApp;
    }
	
	@FXML
	private void connectHandler(){
		InetSocketAddress address = new InetSocketAddress(serverIP.getText(), settings.getSocketAddress().get().getPort());
		settings.setSocketAddress(address);
		updateSettingsStatus();
		mainApp.establishConnetion();
	}

	public void updateSettingsStatus(){   
		InetSocketAddress addr = settings.getSocketAddress().get();
    	StringBuilder status = new StringBuilder("Verbindung herstellen mit ");
    	status.append(addr.getHostName());
    	status.append(" (" + addr.getAddress() + ":" + addr.getPort() + ")");
    	mainApp.setStatus(status.toString());
    	server.setText("Server IP: " + addr.getAddress());
    }

	public void setSettings(Settings settings) {
		this.settings = settings;	
	}
}
