package versuch1_1;

public class Sendungstyp {
	private String bezeichnung;
	private int maxGewicht, maxHoehe, porto;
	
	private static final Sendungstyp[] SENDUNGSTYPEN = {
			new Sendungstyp("Postkarte", 0, 0, 45),
			new Sendungstyp("Standardbrief", 20, 5, 70), 
		 	new Sendungstyp("Kompaktbrief", 50, 10, 85),
		 	new Sendungstyp("Grobrief", 500, 20, 145),
		 	new Sendungstyp("Maxibrief", 1000, 50, 260)
 };

	public static Sendungstyp typ(int gewicht, int hoehe) throws IllegalArgumentException {
		for (Sendungstyp sendung : SENDUNGSTYPEN)
			if (hoehe <= sendung.maxHoehe && gewicht <= sendung.maxGewicht) {
				return sendung;
			}
		throw new IllegalArgumentException("Unbekannter Sendungstyp");
	}

	private Sendungstyp(String bezeichnung, int maxGewicht, int maxHoehe, int porto) {
		this.bezeichnung = bezeichnung;
		this.maxGewicht = maxGewicht;
		this.maxHoehe = maxHoehe;
		this.porto = porto;
	}

	public int getPorto() {
		return porto;
	}

	public String getBezeichnung() {
		return bezeichnung;
	}

}
