package versuch2;

import java.net.*;

import javax.xml.bind.DatatypeConverter;

import versuch2.Lok;
import versuch2.Weiche;

public class MaerklinProtokoll {
	
	private static int port = 15731;
	private static String ip ="192.168.74.118";
	
	private static UDPListener listener;
	
	public MaerklinProtokoll(String ip, int port){
		MaerklinProtokoll.ip = ip;
		MaerklinProtokoll.port = port;
	}
	
	private void sendDatagram(byte[] data){
		System.out.printf("\nGesendet: %3X", data);
		try(DatagramSocket socket = new DatagramSocket()){
			InetAddress  address = InetAddress.getByName(ip);
			DatagramPacket outgoingData = new DatagramPacket(data, data.length, address, port);
			socket.send(outgoingData);
		} 
		catch (Exception e) {
			e.printStackTrace();
		} 
	}
	
	
	public static void printDatagram(byte[] packet){
		byte[] kennung = new byte[4];
		byte[] laenge = new byte [1];
		byte[] nutzdaten = new byte[8];
	
		System.arraycopy(packet, 0, kennung, 0, 4);
		System.arraycopy(packet, 4, laenge, 0, 1);
		System.arraycopy(packet, 5, nutzdaten, 0, 8);
		System.out.print("\n\n   Kennung   DLC Nutzdaten\n " + (char)(0x3C + isResponse(packet)*2) + " " + DatatypeConverter.printHexBinary(kennung) + "  " + DatatypeConverter.printHexBinary(laenge) + "  " + DatatypeConverter.printHexBinary(nutzdaten));
	}

	public static byte makeCID(byte cmd, byte response){
		byte cid = (byte)(cmd + response);
		return cid;
	}
	
	public static byte getCMD(byte[] packet){
		byte cmd = packet[1];
		return cmd;
	}
	
	public static int isResponse(byte[] packet){
		int resp = packet[1]%2;
		return resp;
	}
	
	public static int getMFX(byte[] packet){
		int mfx = packet[7];
		return mfx;
	}
	
	public static int getAddr(byte[] packet){
		int addr = packet[8];
		return addr;
	}

	public static int getSpeed(byte[] packet){
		int speed = packet[9]*256 + packet[10]; //Conversion from two unsigned bytes to a 16 bit Integer
		return speed;
	}
	
	public byte[] setSpeed(int mfxAddress, int newEngineSpeed){
		byte[] engineSpeed = {(byte) Math.floor(newEngineSpeed/256), (byte) Math.floor(newEngineSpeed%256)};
		byte[] address = {(byte) Math.floor(mfxAddress/256), (byte) Math.floor(mfxAddress%256)};
		byte[] out = {(byte) 0x00, (byte) 0x08, (byte) 0x07, (byte) 0x78, (byte) 0x06, (byte) 0x00, (byte) 0x00, address[0], address[1], engineSpeed[0], engineSpeed[1], (byte) 0x00, (byte) 0x00};
		return out;
	}
	
	public static int getDirection(byte[] packet){
		int dir = packet[9];
		return dir;
	}

	public byte[] setDirection(int mfxAddress, int newEngineDirection){
		byte engineDirection = (byte) Math.floor(newEngineDirection%256);
		byte[] address = {(byte) Math.floor(mfxAddress/256), (byte) Math.floor(mfxAddress%256)};
		byte[] out = {(byte) 0x00, (byte) 0x0A, (byte) 0x07, (byte) 0x78, (byte) 0x05, (byte) 0x00, (byte) 0x00, address[0], address[1], engineDirection, (byte) 0x00, (byte) 0x00, (byte) 0x00};
		return out;
	}
	
	public static String printDirection(byte[] packet){
		switch(packet[9]){
		case 1:
			return "forwards";
		case 2:
			return "backwards";
		case 3:
			return "switch";
		default:
			return "unchanged";
		}
	}
	
	
	public byte[] setSwitch(int mfxAddress, int newSwitchDirection){
		byte switchDirection = (byte) Math.floor(newSwitchDirection%256);
		byte address = (byte) Math.floor(mfxAddress%256);
		byte[] out = {(byte) 0x00, (byte) 0x16, (byte) 0x07, (byte) 0x78, (byte) 0x06, (byte) 0x00, (byte) 0x00, (byte) 0x30, address, switchDirection, (byte) 0x01, (byte) 0x00, (byte) 0x00};
		return out;
	}
	
	public static void main(String args[]){
		Lok ice = new Lok(this, listener, 0x0002, "ICE");
		Lok dampflok = new Lok(this, listener, 0x4005, "Dampflok");
		Weiche weiche06 = new Weiche(this, listener, 0x05, "Weiche 6");
		
		try {
			//ice.setEngineSpeed(0);
			//ice.setEngineDirection(2);
			//weiche05.setSwitchDirection(0x00);
			weiche06.toggleDirection();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	}

}
