package versuch2;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import javax.xml.bind.DatatypeConverter;
import java.lang.*;

public class Schniffer extends Thread{
	private final static int port = 15730;
	private final static String ip ="192.168.74.118";
	
	private byte[] in = new byte[13];
	
	public Schniffer(){
		//Nothing to do...
	}
		
	public static void printDatagram(byte[] packet){
		byte[] kennung = new byte[4];
		byte[] laenge = new byte [1];
		byte[] nutzdaten = new byte[8];
	
		System.arraycopy(packet, 0, kennung, 0, 4);
		System.arraycopy(packet, 4, laenge, 0, 1);
		System.arraycopy(packet, 5, nutzdaten, 0, 8);
		System.out.print("\n\n   Kennung   DLC Nutzdaten\n " + (char)(0x3C + isResponse(packet)*2) + " " + DatatypeConverter.printHexBinary(kennung) + "  " + DatatypeConverter.printHexBinary(laenge) + "  " + DatatypeConverter.printHexBinary(nutzdaten));
		//System.out.print("\n" + DatatypeConverter.printHexBinary(packet));
	}

	public static byte makeCID(byte cmd, byte response){
		byte cid = (byte)(cmd<<1 & response);
		return cid;
	}
	
	public static byte getCMD(byte[] packet){
		byte cmd = packet[1];
		return cmd;
	}
	
	public static int isResponse(byte[] packet){
		int resp = packet[1]%2;
		return resp;
	}
	
	public static int getMFX(byte[] packet){
		int mfx = packet[7];
		return mfx;
	}
	
	public static int getAddr(byte[] packet){
		int addr = packet[8];
		return addr;
	}

	public static int getSpeed(byte[] packet){
		int speed = packet[9]*256 + packet[10]; //Conversion from two unsigned bytes to a 16 bit Integer
		return speed;
	}
	
	public static int getDirection(byte[] packet){
		int dir = packet[9];
		return dir;
	}
	
	public static String printDirection(byte[] packet){
		switch(packet[9]){
		case 1:
			return "forwards";
		case 2:
			return "backwards";
		case 3:
			return "switch";
		default:
			return "unchanged";
		}
	}
	
	public static void main(String args[]){
			try(DatagramSocket socket = new DatagramSocket(port)){
				socket.setReuseAddress(true);
				byte[] packet = new byte[13];
				DatagramPacket incomingData = new DatagramPacket(packet, packet.length);
				while (true){
					socket.receive(incomingData);
					printDatagram(packet);
					if(getCMD(packet)==0x08)
						System.out.print("\n   Geschwindigkeit der Lok " + getAddr(packet) + ": " + getSpeed(packet));	
					
					if(getCMD(packet)==0x0A)
						System.out.print("\n   Richtung der Lok " + getAddr(packet) + ": " + getDirection(packet) + "(" + printDirection(packet) + ")");	
					
					if(getCMD(packet)==0x16)
						System.out.print("\n   Status der Weiche " + getAddr(packet) + ": " + getDirection(packet));	
						
					
				}
			} 
			catch (Exception e) {
				e.printStackTrace();
			}
		
		
	}
	
}
