package versuch2;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import javax.xml.bind.DatatypeConverter;

public class UDPListener extends Thread{
	
	private final static int port = 15730;
	
	private byte[] in = new byte[13];
	
	
	public UDPListener(){
		//Nothing to do...
	}
	
	public void listen(){
		try(DatagramSocket socket = new DatagramSocket(port)){
			DatagramPacket incomingData = new DatagramPacket(in, in.length);
			socket.receive(incomingData);
			in = incomingData.getData();
		} 
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public byte[] getData(){
		return in;
	}
	
	public int getEngineSpeed(){
		return (((in[9]&0x7f)<<8)+(in[9]>>7)*65536+(in[10]&0x7f)+(in[10]>>7)*256);
	}
	
	public int getEngineDirection(){
		return (((in[9]&0x7f)<<8)+(in[9]>>7)*65536+(in[10]&0x7f)+(in[10]>>7)*256);
	}
	
	public int getSwitchDirection(){
		return (((in[9]&0x7f)<<8)+(in[9]>>7)*65536+(in[10]&0x7f)+(in[10]>>7)*256);
	}
	
	public void printData(byte[] data){
		try{
			byte[] kennung = new byte[4];
			byte[] laenge = new byte [1];
			byte[] nutzdaten = new byte[8];
			System.arraycopy(data, 0, kennung, 0, 4);
			System.arraycopy(data, 4, laenge, 0, 1);
			System.arraycopy(data, 5, nutzdaten, 0, 8);
			System.out.printf("\n\nKennung  | L  | Nutzdaten\n%3X | %3X | %3X", kennung, laenge, nutzdaten);
		}
		catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public static void main(String args[]){
		UDPListener testListener = new UDPListener();
		while (true){
			testListener.listen();
			testListener.printData(testListener.getData());
		}
	}
	
}
