package versuch2;

public class Weiche {
	
	private int id;
	private String name;
	private int direction;
	
	private MaerklinProtokoll maerklin;
	private UDPListener listener;
	
	public Weiche(MaerklinProtokoll maerklin, UDPListener listener){
		this.maerklin = maerklin;
		this.listener = listener;
	}
	
	public Weiche(MaerklinProtokoll maerklin, UDPListener listener, int id, String name){
		this.maerklin = maerklin;
		this.listener = listener;
		try {
			setID(id);
			setName(name);
		}
		catch(Exception e){
			System.out.println(e.getMessage());
		}
	}
	

	public int getID(){
		return id;
	}
	
	public void setID(int newSwitchID){
		id = newSwitchID;
	}
	

	public String getName(){
		return name;
	}
	
	public void setName(String name){
		this.name = name;
	}
	
	public int getDirection(){
		return direction;
	}
	
	public void setDirection(int newSwitchDirection) throws Exception {
		if (newSwitchDirection == 0x01 || newSwitchDirection == 0x00){
			direction = newSwitchDirection;
		}
		else {
			Exception e = new Exception("No viable switch direction!");
			throw e;
		}
		maerklin.setDirection(id, direction);
		listener.listen();
		if (direction != listener.getSwitchDirection()){
			Exception e = new Exception("Communication Error!");
			throw e;
		}
	}
	
	public void toggleDirection() throws Exception {
		if (direction == 0x00){
			setDirection(0x01);
		}
		else {
			setDirection(0x00);
		}
	}

}
