package udp;

import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

public class MaerklinProtokoll {
	
	public static void changeTrainSpeed(int speed, int uid){
		byte[] changeSpeed = new byte[13];
		changeSpeed[0] = 0;
		changeSpeed[1] = 8;
		changeSpeed[2] = 0x07;
		changeSpeed[3] = 0x78;
		changeSpeed[4] = 6;
		changeSpeed[5] = 0;
		changeSpeed[6] = 0;
		changeSpeed[7] = (byte) (uid/256);
		changeSpeed[8] = (byte) (uid%256);
		changeSpeed[9] = (byte) (speed/256);
		changeSpeed[10] = (byte) (speed%256);
		changeSpeed[11] = 0;
		changeSpeed[12] = 0;
		handleControlSequence(changeSpeed);
	}
	
	public static void changeTrainDirection(int uid){
		byte[] changeDirection = new byte[13];
		changeDirection[0] = 0;
		changeDirection[1] = 10;
		changeDirection[2] = 0x07;
		changeDirection[3] = 0x78;
		changeDirection[4] = 5;
		changeDirection[5] = 0;
		changeDirection[6] = 0;
		changeDirection[7] = (byte) (uid/256);
		changeDirection[8] = (byte) (uid%256);
		changeDirection[9] = 3;
		changeDirection[10] = 0;
		changeDirection[11] = 0;
		changeDirection[12] = 0;
		handleControlSequence(changeDirection);
	}
	
	public static void changeSwitch(int uid,boolean straight){
		byte[] changeSwitch = new byte[13];
		changeSwitch[0] = 0;
		changeSwitch[1] = 22;
		changeSwitch[2] = 0x07;
		changeSwitch[3] = 0x78;
		changeSwitch[4] = 6;
		changeSwitch[5] = 0;
		changeSwitch[6] = 0;
		changeSwitch[7] = (byte) (uid/256);
		changeSwitch[8] = (byte) (uid%256);
		if(straight)
			changeSwitch[9] = 1;
		else
			changeSwitch[9] = 0;
		changeSwitch[10] = 1;
		changeSwitch[11] = 0;
		changeSwitch[12] = 0;
		handleControlSequence(changeSwitch);
	}
	
	public static void handleControlSequence(byte[] bytes){
		try(DatagramSocket socket = new DatagramSocket()){
			InetAddress serverIP = InetAddress.getByName("192.168.74.118");
			int port = 15731;
			DatagramPacket outgoingDatagram = new DatagramPacket(bytes, bytes.length, serverIP,port);
			socket.send(outgoingDatagram);
		}catch(Exception e){
			e.printStackTrace(System.err);
		}
	}
	
}
