package udp;

import java.net.*;
import java.nio.ByteBuffer;
import java.io.*;;

public class UdpSniffer {

	public static void sniffAll(){
		byte[] incomingData = new byte[13];
		int port = 15730;
		
		try(DatagramSocket socket = new DatagramSocket(port)){
			System.out.println("Waiting for a miracle: ");
			while(true){
				DatagramPacket incomingDatagram = new DatagramPacket(incomingData, incomingData.length);
				socket.receive(incomingDatagram);
				InetAddress senderIP = incomingDatagram.getAddress();
				int senderPort = incomingDatagram.getPort();
				System.out.println("Received: "+byteToHex(incomingDatagram.getData())+" from "+senderIP+":"+senderPort);
			}
		}catch(SocketException e){
			e.printStackTrace(System.err);
		}catch(IOException e){
			e.printStackTrace(System.err);
		}
	}
	
	public static byte[] getResponse(){
		byte[] incomingData = new byte[13];
		int port = 15730;
		try(DatagramSocket socket = new DatagramSocket(port)){
			DatagramPacket incomingDatagram = new DatagramPacket(incomingData, incomingData.length);
			socket.receive(incomingDatagram);
			InetAddress senderIP = incomingDatagram.getAddress();
			int senderPort = incomingDatagram.getPort();
			System.out.println("Received: "+byteToHex(incomingDatagram.getData())+" from "+senderIP+":"+senderPort);
			return incomingDatagram.getData();
		}catch(SocketException e){
			e.printStackTrace(System.err);
			return null;
		}catch(IOException e){
			e.printStackTrace(System.err);
			return null;
		}
	}
	
	public static String byteToHex(byte[] bytes){
		StringBuilder sb = new StringBuilder();
		for(byte b : bytes){
			sb.append(String.format("%02X ", b));
		}
		return sb.toString();
	}
	
	public static void main(String[] args){
		try{
			sniffAll();
		}catch(Exception e){
			System.err.println("Invalid Port");
			System.exit(1);
		}
	}
	
	public static void getUpdate(){
		Thread thread = new Thread(new Runnable() {
			@Override
			public void run() {
				byte[] incomingData = new byte[13];
				int port = 15730;
				try(DatagramSocket socket = new DatagramSocket(port)){
					while(true){
						DatagramPacket incomingDatagram = new DatagramPacket(incomingData, incomingData.length);
						socket.receive(incomingDatagram);
						InetAddress senderIP = incomingDatagram.getAddress();
						int senderPort = incomingDatagram.getPort();
						System.out.println("Received: "+UdpSniffer.byteToHex(incomingDatagram.getData())+" from "+senderIP+":"+senderPort);
						byte[] bytes = incomingDatagram.getData();
						byte[] uid = { bytes[7], bytes[8] };
						if(bytes[1]==0x09){
							byte[] arr = { bytes[9], bytes[10] };
							ByteBuffer wrapped = ByteBuffer.wrap(arr);
							short speed = wrapped.getShort();
							System.out.println("Speed changed to "+speed);
							Lok.updateSpeed(uid, speed);
						}else if(bytes[1] == 0x0B){
							if(bytes[9]==1){
								System.out.println("Direction forward");
								Lok.updateDirection(uid, true);
							}else if(bytes[9]==2){
								System.out.println("Direction backwards");
								Lok.updateDirection(uid, false);
							}else if(bytes[9]==3){
								System.out.println("Direction switched");
								Lok.switchDirection(uid);
							}
						}else if(bytes[1] == 0x17){	
							if(bytes[9] == 0){
								System.out.println("Switch is round");
								Weiche.updateState(uid, false);
							}else if(bytes[9] == 1){
								System.out.println("Switch is straight");
								Weiche.updateState(uid, true);
							}
						}
					}
				}catch(SocketException e){
					e.printStackTrace(System.err);
				}catch(IOException e){
					e.printStackTrace(System.err);
				}
			}
		});
		thread.start();
	}
}
