package versuch1_3;

import static org.junit.Assert.*;

import java.util.concurrent.ThreadLocalRandom;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;


public class TicTacToeTest{
	private static TicTacToe ttt;
	private static TicTacToeMockup tttm;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
		tttm = new TicTacToeMockup();
		ttt = new TicTacToe(tttm);
		
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
		ttt = null;
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test // Test 1: Gewinnbedingungen
	public void test1() {
		int max = ttt.getSpielbrett().length;
		final char gewinn[][][] = new char [4][3][3];
		char spieler=' ';	
		for (int a = 0; a < 2;a++){
			switch(a){
			case 0:
				spieler = 'X';
				break;
			case 1:
				spieler = 'O';
				break;
			}
			for (int b = 0;b < 4;b++){
				switch(b){
				case 0:
					for (int i=0;i < max;  i++){
						gewinn[b][i][1]=spieler;
					}
					break;
				case 1:
					for (int i=0;i < max;  i++){
						gewinn[b][1][i]=spieler;
					}
					break;
				case 2:
					for (int i=0;i < max;  i++){
						gewinn[b][i][i]=spieler;
					}
					break;
				case 3:
					for (int i=0;i < max;  i++){
						gewinn[b][i][2-i]=spieler;
					}
					break;
				}
				ttt.setSpielbrett(gewinn[b]);
				assertEquals("Spielende fr Spieler " + spieler + " in Fall " + b + " nicht erkannt", TicTacToe.ENTSCHIEDEN, ttt.getSpielzustand());
			}
			char[][] patt = {{'O','X','X'},{'X','O','O'},{'O','X','X'}};
			ttt.setSpielbrett(patt);
			assertEquals("Unentschieden nich erkannt", TicTacToe.UNENTSCHIEDEN, ttt.getSpielzustand());
			
			// 
			char[][] luft = {{'O','O',' '},{' ',' ',' '},{' ','X','X'}};
			ttt.setSpielbrett(luft);
			assertEquals("Laufendes Spiel nicht erkannt", TicTacToe.LAEUFT, ttt.getSpielzustand());
			
		}
			
	}
	
	@Test // Test 2: Gltigkeit der Eingabe
	public void test2() {
		int max = ttt.getSpielbrett().length;
		assertFalse("Ungltige Koordinaten nicht erkannt",ttt.isGueltig(max+1, max+1));
		
		char[][] voll = new char[max][max];
		for (int i = 0; i < max; i++){
			for (int j = 0; j < max; j++){
				voll[i][j]='X';
			}
		}
		ttt.setSpielbrett(voll);
		for (int i = 0; i < max; i++){
			for (int j = 0; j < max; j++){
				assertFalse("Belegung nicht erkannt: " + i + "," + j,ttt.isGueltig(i, j));
			}
		}
		char[][] leer = new char[max][max];
		for (int i = 0; i < max; i++){
			for (int j = 0; j < max; j++){
				leer[i][j]=' ';
			}
		}
		ttt.setSpielbrett(leer);
		for (int i = 0; i < max; i++){
			for (int j = 0; j < max; j++){
				assertTrue("Freies Feld nicht erkannt: " + i + "," + j,ttt.isGueltig(i, j));
			}
		}
	}
	
	@Test // Test 3: Nchster Spieler
	public void test3() {
		assertEquals("Nchsten Spieler falsch bestimmt",1,ttt.getNaechstenSpieler(0));

		assertEquals("Nchsten Spieler falsch bestimmt",0,ttt.getNaechstenSpieler(1));
		
		int spieler = ThreadLocalRandom.current().nextInt(2, 100+1);
		assertEquals("Nchsten Spieler fr zuflliges Argument " + spieler + " falsch bestimmt",(spieler+1)%2,ttt.getNaechstenSpieler(spieler));
	}
	
	@SuppressWarnings("unused")
	@Test // Test 4: Nutzereingabe
	public void test4() {
		String zugEingabe;
		
		//gltige Eingabe
		ttt.resetSpiel();
		zugEingabe = "12";
		tttm.setZugeingabe(zugEingabe);
		ttt.spielzug(0);
		char[][] spielbrett = ttt.getSpielbrett();
		assertFalse("Gltigen Spielzug nicht umgesetzt", spielbrett[1][2] == ' ');
		
		
		//Abbruch
		ttt.resetSpiel();
		spielbrett = ttt.getSpielbrett();
		zugEingabe = "a";
		tttm.setZugeingabe(zugEingabe);
		assertEquals("Abbruch nicht erkannt", TicTacToe.ABGEBROCHEN,ttt.spielzug(0));
		assertTrue("Ungltige Eingabe als Zug umgesetzt!", spielbrett.equals(ttt.getSpielbrett()));
		
		//zufllige Zeichenkette
		spielbrett = ttt.getSpielbrett();
		char[] zuflligeEingabe = new char[ThreadLocalRandom.current().nextInt(1, 5+1)];
		for (char c:zuflligeEingabe){
			c = (char)ThreadLocalRandom.current().nextInt(48, 125+1);
		}
		tttm.setZugeingabe(zuflligeEingabe.toString());
		assertTrue("Ungltige Eingabe als Zug umgesetzt!", spielbrett.equals(ttt.getSpielbrett()));
		
	}
	
	@Test // Test 5: Gewinner
	public void test5() {
		char[][] gewinn = {{'O','O','O'},{' ',' ',' '},{' ',' ',' '}};
		ttt.setSpielbrett(gewinn);
		char gewinner = ttt.getGewinner();
		assertEquals("Gewinner falsch ermittelt",'O', gewinner);
		
	}
	
	@Test(expected=IndexOutOfBoundsException.class) 
	// Test 6: Spielzug Exception
	public void test6() {
		int spieler = ThreadLocalRandom.current().nextInt(2, 100+1);
		ttt.spielzug(spieler);
	}
	
	@SuppressWarnings("unused")
	private void printSpielbrett(char[][] spielbrett){
		String ausgabe = "+-+-+-+\n";
		for (char[] zeile:spielbrett){
			for (char spielfeld:zeile) {
				ausgabe += "|" + spielfeld;
			}
			ausgabe += "|\n+-+-+-+\n";
		}
		System.out.print(ausgabe);
	}
	private boolean compareSpielbrett(char[][] a,char[][] b){
		boolean isEqual = true;
		try{
			for(int i = 0 ; i < a.length ; i++){
				for (int j = 0 ; j < a[i].length ; j++){
					if (a[i][j] != b[i][j])
						isEqual = false;
				}
			}
		}catch(ArrayIndexOutOfBoundsException e){
			isEqual = false;
		}
		return isEqual;
	}
	
	private int spieldurchlauf(String[] spielX,String [] spielO) {
		tttm.setSpiel(spielX, spielO);
		ttt.resetSpiel();
		int i;
		for(i = 0 ; i < (spielX.length + spielO.length) && ttt.getSpielzustand() == TicTacToe.LAEUFT ; i++){
			ttt.spielzug(i%2);
			//printSpielbrett(ttt.getSpielbrett());
		}
		return i;
	}
	
	@Test // Test 7: Spieldurchlauf
	public void test7(){
		// X gewinnt
		char[][] winX = {{'X',' ','O'},{'X',' ','O'},{'X',' ',' '}};
		String[] spielX = {"00","10","20","21","22"};
		String[] spielO = {"02","12","22","20","22"};
		spieldurchlauf(spielX, spielO);
		assertEquals("Spielende nicht erkannt", TicTacToe.ENTSCHIEDEN, ttt.getSpielzustand());
		assertEquals("Gewinner nicht erkannt", 'X', ttt.getGewinner());
		//printSpielbrett(ttt.getSpielbrett());
		//printSpielbrett(winX);
		assertTrue("Spielzge nicht richtig umgesetzt", compareSpielbrett(ttt.getSpielbrett(),winX));
		
		// unentschieden
		char[][] patt = {{'O','X','X'},{'X','O','O'},{'O','X','X'}};
		String[] pattX = {"01","02","10","21","22"};
		String[] pattO = {"00","11","12","20","20"};
		spieldurchlauf(pattX, pattO);
		assertEquals("Unentschieden nicht erkannt", TicTacToe.UNENTSCHIEDEN, ttt.getSpielzustand());
		assertEquals("Falschen Gewinner erkannt", ' ', ttt.getGewinner());
		assertTrue("Spielzge nicht richtig umgesetzt", compareSpielbrett(patt,ttt.getSpielbrett()));
	}
	
	@Test // Test 8: Spielzge zhlen
	public void test8() {
		String[] spielX = {"00","10","20","21","22"};
		String[] spielO = {"02","12","22","20","22"};
		assertEquals("Spielzge falsch gezhlt!",spieldurchlauf(spielX, spielO),ttt.getZaehlerSpielzug());
	}
}
